#include <tonc.h>
#include "include/link.h"
#include "include/sprite.h"

void Link_Create(ObjectLink *Link,s32 x,s32 y,u32 direction){
  Object_Create(&(Link->objLink),x,y,direction);
  GRIT_CPY(pal_obj_mem,link_gfxPal);
  GRIT_CPY(tile_mem[4],link_gfxTiles);
}

void Link_Step(ObjectLink *Link){
  Link->objLink.keyU = (key_is_down(KEY_UP) != 0);
  Link->objLink.keyD = (key_is_down(KEY_DOWN) != 0);
  Link->objLink.keyL = (key_is_down(KEY_LEFT) != 0);
  Link->objLink.keyR = (key_is_down(KEY_RIGHT) != 0);
  direction_set(&(Link->objLink));
  movement_norm(&(Link->objLink));
}

void Link_Draw(ObjectLink *Link){
  if (Link->objLink.direction == 90)
    draw_sprite(sprLinkStandU,Link->objLink.x,Link->objLink.y);
  else if (Link->objLink.direction == 270)
    draw_sprite(sprLinkStandD,Link->objLink.x,Link->objLink.y);
  else if (Link->objLink.direction == 180)
    draw_sprite(sprLinkStandL,Link->objLink.x,Link->objLink.y);
  else
    draw_sprite(sprLinkStandR,Link->objLink.x,Link->objLink.y);	
  draw_sprite(sprLinkShadow,Link->objLink.x,Link->objLink.y);
}