#include <tonc.h>
#include "include/object.h"

void Object_Create(Object *obj,s32 x,s32 y,u32 direction){
  obj->y = y << 8; obj->x = x << 8;
  obj->stepY = 0; obj->stepX = 0;
  obj->moveY = 0; obj->moveX = 0;
  obj->direction = direction;
  obj->keyU = FALSE; obj->keyD = FALSE;
  obj->keyL = FALSE; obj->keyR = FALSE;
  obj->maxiY = 0x00E4E1C0; obj->maxiX = 0x00E4E1C0;
}

void direction_set(Object *obj){
  if ((obj->keyL || obj->keyR) && (obj->keyU || obj->keyD)){
    if (obj->keyU && obj->direction == 270)
      obj->direction = 90;
    else if (obj->keyD && obj->direction == 90)
      obj->direction = 270;
    else if (obj->keyL && obj->direction == 0)
      obj->direction = 180;
    else if (obj->keyR && obj->direction == 180)
      obj->direction = 0;
  }
  else if (obj->keyU) 
    obj->direction = 90;
  else if (obj->keyD)
    obj->direction = 270;
  else if (obj->keyL)
    obj->direction = 180;
  else if (obj->keyR)
    obj->direction = 0;
}

void movement_norm(Object *obj){
  unsigned int absvY,absvX,moveF,loopC;
  obj->moveY = (obj->keyD - obj->keyU) * obj->maxiY;
  obj->moveX = (obj->keyR - obj->keyL) * obj->maxiX;
  absvY = ABS(obj->moveY);
  absvX = ABS(obj->moveX);
  if (absvY || absvX){
    if (absvY && absvX){
      moveF = MOVE_DIAGONAL;
      if (absvY == obj->maxiY && absvX == obj->maxiX)
        obj->stepY = obj->stepX;
    }
    else
      moveF = MOVE_LINEAR;
    if (absvY){
      loopC = 0;
      obj->stepY += absvY;
      while (obj->stepY >= MOVE_LINEAR){
        loopC += 0x100;
        obj->stepY -= moveF;
      }
      if (loopC)
	    obj->y += loopC * SGN(obj->moveY);
    }
    if (absvX){
      loopC = 0;
      obj->stepX += absvX;
      while (obj->stepX >= MOVE_LINEAR){
        loopC += 0x0100;
        obj->stepX -= moveF;
      }
      if (loopC)
        obj->x += loopC * SGN(obj->moveX);
    }
  }
  else{
    obj->stepY = 0;
    obj->stepX = 0;
  }
}