#include <tonc.h>
#include "include/sprite.h"

extern OBJ_ATTR sprite_list[];
extern unsigned int sprite_count;

//******************************************************************************
//* LINK SPRITES                                                               *
//******************************************************************************

static void scr_sprLinkStandU(s32 x,s32 y){
  POINT pt = {(x>>8),(y>>8)};
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(0) | 0);
  obj_set_pos(&spr[sprite_count],pt.x - 8,pt.y - 20);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 4);
  obj_set_pos(&spr[sprite_count+1],pt.x - 8,pt.y - 4);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 6);
  obj_set_pos(&spr[sprite_count+2],pt.x - 16,pt.y - 12);
  obj_set_attr(&spr[sprite_count+3],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(0) | 6);
  obj_set_pos(&spr[sprite_count+3],pt.x + 8,pt.y - 12);
  sprite_count += 4;
}

static void scr_sprLinkStandD(s32 x,s32 y){
  POINT pt = {(x>>8),(y>>8)};
  OBJ_ATTR *spr = &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(0) | 7);
  obj_set_pos(&spr[sprite_count],pt.x - 8,pt.y - 20);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 11);
  obj_set_pos(&spr[sprite_count+1],pt.x - 8,pt.y - 4);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 13);
  obj_set_pos(&spr[sprite_count+2],pt.x - 16,pt.y - 19);
  obj_set_attr(&spr[sprite_count+3],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(0) | 13);
  obj_set_pos(&spr[sprite_count+3],pt.x + 8,pt.y - 19);
  sprite_count += 4;
}

static void scr_sprLinkStandL(s32 x,s32 y){
  POINT pt = {(x>>8),(y>>8)};
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16,
               ATTR2_PALBANK(0) | 14);
  obj_set_pos(&spr[sprite_count],pt.x - 6,pt.y - 21);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 18);
  obj_set_pos(&spr[sprite_count+1],pt.x - 6,pt.y - 5);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(0) | 20);
  obj_set_pos(&spr[sprite_count+2],pt.x - 14,pt.y - 21);
  sprite_count += 3;
}

static void scr_sprLinkStandR(s32 x,s32 y){
  POINT pt = {(x>>8),(y>>8)};
  OBJ_ATTR *spr= &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_SQUARE,
               ATTR1_SIZE_16 | ATTR1_HFLIP,
               ATTR2_PALBANK(0) | 14);
  obj_set_pos(&spr[sprite_count],pt.x - 10,pt.y - 21);
  obj_set_attr(&spr[sprite_count+1],
               ATTR0_WIDE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(0) | 18);
  obj_set_pos(&spr[sprite_count+1],pt.x - 10,pt.y - 5);
  obj_set_attr(&spr[sprite_count+2],
               ATTR0_SQUARE,
               ATTR1_SIZE_8 | ATTR1_HFLIP,
               ATTR2_PALBANK(0) | 20);
  obj_set_pos(&spr[sprite_count+2],pt.x + 6,pt.y - 21);
  sprite_count += 3;
}

static void scr_sprLinkShadow(s32 x,s32 y){
  POINT pt = {(x>>8),(y>>8)};
  OBJ_ATTR *spr = &sprite_list[0];
  obj_set_attr(&spr[sprite_count],
               ATTR0_WIDE,
               ATTR1_SIZE_8,
               ATTR2_PALBANK(1) | 21);
  obj_set_pos(&spr[sprite_count],pt.x - 8,pt.y - 2);
  sprite_count += 1;
}

//******************************************************************************
//******************************************************************************

static void (*spriteFunctions[5])(s32,s32) = {
  &scr_sprLinkStandU,
  &scr_sprLinkStandD,
  &scr_sprLinkStandL,
  &scr_sprLinkStandR,
  &scr_sprLinkShadow
};

void draw_sprite(u32 sprite_index,s32 x,s32 y){
  (*spriteFunctions[sprite_index])(x,y);
}